class GeologyLogViewer(QWidget):
    @classmethod
    def name(cls):
        return "GW Geology log"
    
    @classmethod
    def xml_tag(cls):
        # the XML tag (with namespace) this widget is meant for
        # the second element of the tuple is an XPath filter
        return ("{http://www.opengis.net/om/2.0}OM_Observation",
                "./om:type[@xlink:href='http://www.opengis.net/def/observationType/OGC-GWML/2.2/GW_GeologyLog']")

    @classmethod
    def icon(cls):
        return QIcon(os.path.join(os.path.dirname(__file__), "drill.svg"))

    @classmethod
    def init_from_xml(cls, xml_tree):
        # parse data
        data = []
        description = resolve_xpath(xml_tree, "description/text()")
        logs = resolve_xpath(xml_tree, "result/GW_GeologyLogCoverage/element/LogValue")
        data = []
        for log in logs:
            fromDepth = float(resolve_xpath(log, "fromDepth/Quantity/value/text()"))
            toDepth = float(resolve_xpath(log, "toDepth/Quantity/value/text()"))
            value_text = resolve_xpath(log, "value/DataRecord/field/Text/value/text()")
            value_cat = resolve_xpath(log, "value/DataRecord/field/Category/value/text()")
            value = value_text if value_text is not None else value_cat
            data.append((fromDepth, toDepth, value))
        return cls(description, data)
    
    def __init__(self, title, data, parent = None):
        QWidget.__init__(self, parent)
        # ...
